# TSFS19: Battery Systems

<!--**Lecturer**: Mattias Krysander ([mattias.krysander@liu.se](mailto:mattias.krysander@liu.se))-->

This repository includes lecture notes, material for exercise sessions, computer labs, links to reading material, and other course material. Information here will be added during the course, and you can always get the latest version of course material here. 

The course consists of lectures, exercise sessions, computer labs, and a written examination.


## Table of Contents

- [Curriculum](https://studieinfo.liu.se/en/kurs/TSFS19/vt-2025)
- [Schedule](https://cloud.timeedit.net/liu/web/schema/riqmZQY76ZXZ27Qy3Y7Q14c06bZ596Q6m0c0053Q9Yo5Qga5pZZ7Qq6Qo.html)
- [Lecture Plan](#lecture-plan)
- [Exercise Sessions](#exercise-sessions)
- [Computer Labs](#computer-labs)
- [Exam](#exam)
- [Reading Material](#reading-material)
- [Public Battery Data](#public-battery-data)

## Lecture Plan
The table below shows the lecture plan for the course. The lecture slides and notes will be added to the [Lectures](Lectures) folder during the course. The column "Prep for" indicates which exercise sessions and computer labs you should be prepared for after attending the corresponding lecture. The table also includes recommended reading materials, which are not mandatory but can enhance your understanding of the course content. EE stands for the book "Electrochemical Engineering" by Tomas Fuller and John Harb. Reading material is provided in the [Lisam](https://liuonline.sharepoint.com/:f:/r/sites/Lisam_TSFS19_2025VT_59/CourseDocuments/Reading%20Material?csf=1&web=1&e=ff480K). 


| Lec | Date | Topic                                    | Prep for | Reading Instructions |
|-----|----|-------------------------------------------|---------|---------------|
| 1 |1/4|    Battery introduction [Slides](Lectures/Lec1.pdf) [Notes](Lectures/Notes1.pdf) |  | EE, 1, 2-2.4 
| 2 |2/4|    Battery properties <!--[Slides](Lectures/Lec2.pdf) [Notes](Lectures/Notes2.pdf)-->   | Ex 1,2 | EE, 7 (not p 161)
| 3  |7/4|  Battery modeling <!--[Slides](Lectures/Lec3.pdf) [Notes](Lectures/Notes3.pdf)--> | Ex 3 | [BMS I.2](http://mocha-java.uccs.edu/ECE5710/ECE5710-Notes02.pdf)
| 4  |9/4| Battery modeling <!--[Slides](Lectures/Lec4.pdf)-->                         | Ex 4, Lab 1 | [BMS I.2](http://mocha-java.uccs.edu/ECE5710/ECE5710-Notes02.pdf)
| 5   |14/4| State of charge estimation <!--[Slides](Lectures/Lec5.pdf)-->               | Ex 5, Lab 2 | [BMS II.3](http://mocha-java.uccs.edu/ECE5720/ECE5720-Notes03.pdf) (3.1-3.3, 3.8, 3.12)
| 6   |23/4| Battery pack design <!--[Slides](Lectures/Lec6.pdf) [Notes](Lectures/Notes6.pdf)-->                    | Ex 6,  | EE 8, [BMS II.1](http://mocha-java.uccs.edu/ECE5720/ECE5720-Notes01.pdf)
| 7   |30/4| Simulation of cells and battery packs <!--[Slides](Lectures/Lec7/Lec7_Slides.pdf)-->    | Ex 7, Lab 3 | EE 12, [BMS II.2](http://mocha-java.uccs.edu/ECE5720/ECE5720-Notes02.pdf)
| 8   |6/5| Electric vehicle application <!--[Slides](Lectures/Lec8/Lec8_Slides.pdf)-->  |Lab 4 |   
| 9   |12/5| Cell balancing <!--[Slides](Lectures/Lec9/Lec9_Slides.pdf)-->        | Ex 9 | [BMS II.5](http://mocha-java.uccs.edu/ECE5720/ECE5720-Notes05.pdf) <!--[BMS II.4.1-4.3](Reading_material/04-Battery-Health-Estimation.pdf)-->
| 10  |20/5| Exam preparation. Possible guest lecture. | Ex 10  | [Exam241218](Exams/exam241218.pdf) <!--[BMS II.6](Reading_material/06-Voltage-Based-Power-Limit-Estimation.pdf)-->

## Exercise Sessions

The exercises are provided in the [Exercises](Exercises) folder. **A computer with a Matlab installation is required to solve many exercises.**

The table below shows the exercises for each session. The exercises in **bold are the recommended exercises** to solve during the sessions. The other exercises are supplementary. The exercises are coarsely categorized in difficulty level: Easy, Standard, and Extra. Introductionary exercises are marked easy, standard exercises are for students aiming for a passing grade, and extra tasks are recommended for students aiming for a higher grade or to deepen their understanding of the subject.

|Ex |Date  | Recommended Tasks | All Tasks           
|---|----- |-------------------|-------------------------|
| 1 | 2/4  | 1.1, 1.2, 1.3, 1.6, 1.7, 1.9 | 1.1-1.12  |
| 2 | 4/4  | 2.1, 2.2, 2.3, 2.5, 2.6, 2.7 | 2.1-2.10  |
| 3 | 8/4  | 3.1, 3.2, 3.3, 3.4 | 3.1-3.7 | 
| 4 | 9/4  | 3.5, 3.6 | 3.1-3.7 |
| 5 | 15/4 | 4.1, 4.2, 4.4, 4.5 |4.1 - 4.6 |
| 6 | 23/4 | TBD | 5.1-5.7 |  
| 7 | 30/4 | Not used
| 8 | 7/5  | TBD            | 6.1-6.6 | 
| 9 | 13/5 | TBD            | 7.1-7.6 |  
|10 | 21/5 | Exam preparation |  |

<!--
| Lesson   | Easy Tasks        | Standard Tasks           | Extra Tasks        |
|----------|------------------|-------------------------|--------------------|
| Lesson 1 | **1.1**, **1.2**, **1.3**, **1.6** | 1.4, 1.5, **1.7**, **1.9**, 1.10 | 1.8, 1.11, 1.12  |
| Lesson 2 | **2.1**, **2.2**, **2.3** | 2.4 (D), **2.5**, **2.6**, **2.7 (D)** | 2.8, 2.9, 2.10 (D) |
| Lesson 3 | **3.1**, **3.2**, 3.3, 3.6 | 3.4, 3.5, 3.7 |  |
| Lesson 4 | **4.1**, **4.2**, 4.3, **4.4** | **4.5**, 4.6 |  |
| Lesson 5 | **5.1**, **5.2**, 5.4, 5.5, 5.6 | 5.3 | 5.7 |
| Lesson 6 | **6.1**, 6.2, **6.3**, 6.4 | 6.5, 6.6 |  |
| Lesson 7 | 7.1, 7.2, 7.3, 7.4 | 7.5, 7.6 |  |
| Lesson 8 |  |  |  |
| Lesson 9 |  |  |  |
-->

## Computer Labs

The computer labs are provided in the [Labs](Labs) folder. The first two labs are designed for **Python**, while the final lab is designed for **Matlab**. The labs are done in pairs (groups of two students).

Lab sessions are scheduled in rooms without computers, so you should bring your laptop and collaborate with your lab partner. The labs are assessed during the sessions by demonstrating and discussing your work with the lab assistant.

Each lab includes preparation tasks that should be completed before the session starts. It is also possible to complete the labs at home and only attend the scheduled session for the examination. If you fall behind, you can catch up on previous labs during the lab sessions.

### Lab 1: Battery Modeling

### Lab 2: State of Charge Estimation

### Lab 3: Battery Charging

## Exam

The exam is a written exam with a duration of 4 hours. The number of questions will be around 5 with a total of 40 points and the allowed aids are a ruler, calculator, and a formula sheet. The grade will be based on preliminary the following scale:
* 0-16 points:  U (Fail)
* 17-24 points: 3 (Pass)    
* 25-32 points: 4 (Good)
* 33-40 points: 5 (Excellent)

Old exams are available in the [Exams](Exams) folder.
* [exam241218](Exams/exam241218.pdf) 

## Reading Material

* [Electrochemical Engineering](https://liuonline.sharepoint.com/:b:/r/sites/Lisam_TSFS19_2025VT_59/CourseDocuments/Reading%20Material/Electrochemical_Engineering.pdf?csf=1&web=1&e=Q0dHgA) (EE), Tomas Fuller, John Harb, John Wiley & Sons, 20 mars 2018.
* [Matthew Lacey](https://lacey.se/projects) provides educational material for battery modeling among other things a lot of information about Electrochemical Impedance Spectroscopy (EIS).


## Public Battery Data
- [Battery data](https://calce.umd.edu/data) including 6 data sets from the University of Maryland. INR 18650-20R is a candidate data set for the first lab.
- [ESC model toolbox (1.2GB)](http://mocha-java.uccs.edu/BMS1/CH02/ESCtoolbox.zip) contains data sets for 6 different batteries from the University of Colorado.
